Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMListBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMListBox.cpp	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMListBox.cpp	(revision 7615)
@@ -467,5 +467,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap::fromMimeSource ("os_other.png");
+        pmOSType = QPixmap::fromMimeSource ("os_unknown.png");
         pmState = QPixmap::fromMimeSource ("state_aborted_16px.png");
         strState = VBoxVMListBox::tr ("Inaccessible");
@@ -503,5 +503,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap::fromMimeSource ("os_other.png");
+        pmOSType = QPixmap::fromMimeSource ("os_unknown.png");
         pmState = QPixmap::fromMimeSource ("state_aborted_16px.png");
     }
@@ -685,5 +685,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap::fromMimeSource ("os_other.png");
+        pmOSType = QPixmap::fromMimeSource ("os_unknown.png");
         pmState = QPixmap::fromMimeSource ("state_aborted_16px.png");
         strState = VBoxVMListBox::tr ("Inaccessible");
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxCloseVMDlg.ui	(revision 7615)
@@ -71,5 +71,5 @@
                             </property>
                             <property name="pixmap">
-                                <pixmap>os_other.png</pixmap>
+                                <pixmap>os_unknown.png</pixmap>
                             </property>
                             <property name="scaledContents">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxNewVMWzd.ui	(revision 7615)
@@ -341,5 +341,5 @@
                                 </property>
                                 <property name="pixmap">
-                                    <pixmap>os_other.png</pixmap>
+                                    <pixmap>os_unknown.png</pixmap>
                                 </property>
                                 <property name="scaledContents">
Index: trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox/ui/VBoxTakeSnapshotDlg.ui	(revision 7615)
@@ -72,5 +72,5 @@
                             </property>
                             <property name="pixmap">
-                                <pixmap>os_other.png</pixmap>
+                                <pixmap>os_unknown.png</pixmap>
                             </property>
                             <property name="scaledContents">
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMListBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMListBox.cpp	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMListBox.cpp	(revision 7615)
@@ -478,5 +478,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap (":/os_other.png");
+        pmOSType = QPixmap (":/os_unknown.png");
         pmState = QPixmap (":/state_aborted_16px.png");
         strState = VBoxVMListBox::tr ("Inaccessible");
@@ -514,5 +514,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap (":/os_other.png");
+        pmOSType = QPixmap (":/os_unknown.png");
         pmState = QPixmap (":/state_aborted_16px.png");
     }
@@ -696,5 +696,5 @@
     {
         /// @todo (r=dmik) temporary
-        pmOSType = QPixmap (":/os_other.png");
+        pmOSType = QPixmap (":/os_unknown.png");
         pmState = QPixmap (":/state_aborted_16px.png");
         strState = VBoxVMListBox::tr ("Inaccessible");
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxCloseVMDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxCloseVMDlg.ui	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxCloseVMDlg.ui	(revision 7615)
@@ -33,5 +33,5 @@
          </property>
          <property name="pixmap" >
-          <pixmap>:/os_other.png</pixmap>
+          <pixmap>:/os_unknown.png</pixmap>
          </property>
          <property name="scaledContents" >
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxTakeSnapshotDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxTakeSnapshotDlg.ui	(revision 7614)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxTakeSnapshotDlg.ui	(revision 7615)
@@ -72,5 +72,5 @@
                             </property>
                             <property name="pixmap">
-                                <pixmap>:/os_other.png</pixmap>
+                                <pixmap>:/os_unknown.png</pixmap>
                             </property>
                             <property name="scaledContents">