Index: trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c	(revision 7625)
+++ trunk/src/VBox/Additions/common/VBoxGuest/VBoxGuest-solaris.c	(revision 7626)
@@ -57,5 +57,5 @@
 static int VBoxGuestSolarisRead(dev_t Dev, struct uio *pUio, cred_t *pCred);
 static int VBoxGuestSolarisWrite(dev_t Dev, struct uio *pUio, cred_t *pCred);
-static int VBoxGuestSolarisIOCtl(dev_t Dev, int Cmd, intptr_t pArg, int mode, cred_t *pCred, int *pVal);
+static int VBoxGuestSolarisIOCtl(dev_t Dev, int Cmd, intptr_t pArg, int Mode, cred_t *pCred, int *pVal);
 
 static int VBoxGuestSolarisGetInfo(dev_info_t *pDip, ddi_info_cmd_t enmCmd, void *pArg, void **ppResult);
@@ -73,5 +73,5 @@
 
 /*******************************************************************************
-*   Global Variables                                                           *
+*   Structures and Typedefs                                                    *
 *******************************************************************************/
 /**
@@ -167,6 +167,10 @@
     PVBOXGUESTSESSION       pSession;
 #endif
-} VBoxAddDevState;
-
+} vboxguest_state_t;
+
+
+/*******************************************************************************
+*   Global Variables                                                           *
+*******************************************************************************/
 /** Device handle (we support only one instance). */
 static dev_info_t *g_pDip;
@@ -195,5 +199,5 @@
 {
     LogFlow((DEVICE_NAME ":_init\n"));
-    int rc = ddi_soft_state_init(&g_pVBoxGuestSolarisState, sizeof(VBoxAddDevState), 1);
+    int rc = ddi_soft_state_init(&g_pVBoxGuestSolarisState, sizeof(vboxguest_state_t), 1);
     if (!rc)
     {
@@ -240,5 +244,5 @@
             int rc;
             int instance;
-            VBoxAddDevState *pState;
+            vboxguest_state_t *pState;
 
             instance = ddi_get_instance(pDip);
@@ -259,8 +263,8 @@
             }
 #else
-            pState = RTMemAllocZ(sizeof(VBoxAddDevState));
+            pState = RTMemAllocZ(sizeof(vboxguest_state_t));
             if (!pState)
             {
-                Log((DEVICE_NAME ":RTMemAllocZ failed to allocate %d bytes\n", sizeof(VBoxAddDevState)));
+                Log((DEVICE_NAME ":RTMemAllocZ failed to allocate %d bytes\n", sizeof(vboxguest_state_t)));
                 return DDI_FAILURE;
             }
@@ -355,5 +359,5 @@
                                             }
                                             else
-                                                Log((DEVICE_NAME ":VBoxGuestInitDevExt failed.\n"));
+                                                LogRel((DEVICE_NAME ":VBoxGuestInitDevExt failed.\n"));
                                             VBoxGuestSolarisRemoveIRQ(pDip, pState);
                                         }
@@ -363,18 +367,18 @@
                                     }
                                     else
-                                        Log((DEVICE_NAME ":ddi_regs_map_setup for MMIO region failed.\n"));
+                                        LogRel((DEVICE_NAME ":ddi_regs_map_setup for MMIO region failed.\n"));
                                 }
                                 else
-                                    Log((DEVICE_NAME ":ddi_dev_regsize for MMIO region failed.\n"));
+                                    LogRel((DEVICE_NAME ":ddi_dev_regsize for MMIO region failed.\n"));
                                 ddi_regs_map_free(&pState->PciIOHandle);
                             }
                             else
-                                Log((DEVICE_NAME ":ddi_regs_map_setup for IOport failed.\n"));
+                                LogRel((DEVICE_NAME ":ddi_regs_map_setup for IOport failed.\n"));
                         }
                         else
-                            Log((DEVICE_NAME ":PCI class/sub-class does not match.\n"));
+                            LogRel((DEVICE_NAME ":PCI class/sub-class does not match.\n"));
                     }
                     else
-                        Log((DEVICE_NAME ":PCI vendorID, deviceID does not match.\n"));
+                        LogRel((DEVICE_NAME ":PCI vendorID, deviceID does not match.\n"));
                     pci_config_teardown(&PciHandle);
                 }
@@ -385,5 +389,5 @@
             }
             else
-                Log((DEVICE_NAME ":RTSpinlockCreate failed.\n"));
+                LogRel((DEVICE_NAME ":RTSpinlockCreate failed.\n"));
 
             RTR0Term();
@@ -421,7 +425,7 @@
             int instance = ddi_get_instance(pDip);
 #ifdef USE_SESSION_HASH
-            VBoxAddDevState *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, instance);
+            vboxguest_state_t *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, instance);
 #else
-            VBoxAddDevState *pState = ddi_get_driver_private(g_pDip);
+            vboxguest_state_t *pState = ddi_get_driver_private(g_pDip);
 #endif
             if (pState)
@@ -465,10 +469,10 @@
  * @param   pDip            The module structure instance (do not use).
  * @param   enmCmd          Information request type.
- * @param   pArg            Type specific argument.
- * @param   ppResult        Where to store the requested info.
+ * @param   pvArg           Type specific argument.
+ * @param   ppvResult       Where to store the requested info.
  *
  * @return  corresponding solaris error code.
  */
-static int VBoxGuestSolarisGetInfo(dev_info_t *pDip, ddi_info_cmd_t enmCmd, void *pArg, void **ppResult)
+static int VBoxGuestSolarisGetInfo(dev_info_t *pDip, ddi_info_cmd_t enmCmd, void *pvArg, void **ppvResult)
 {
     LogFlow((DEVICE_NAME ":VBoxGuestSolarisGetInfo\n"));
@@ -478,9 +482,9 @@
     {
         case DDI_INFO_DEVT2DEVINFO:
-            *ppResult = (void *)g_pDip;
+            *ppvResult = (void *)g_pDip;
             break;
 
         case DDI_INFO_DEVT2INSTANCE:
-            *ppResult = (void *)(uintptr_t)ddi_get_instance(g_pDip);
+            *ppvResult = (void *)(uintptr_t)ddi_get_instance(g_pDip);
             break;
 
@@ -489,4 +493,6 @@
             break;
     }
+
+    NOREF(pvArg);
     return rc;
 }
@@ -510,5 +516,5 @@
 
 #ifndef USE_SESSION_HASH
-    VBoxAddDevState *pState = NULL;
+    vboxguest_state_t *pState = NULL;
     unsigned iOpenInstance;
     for (iOpenInstance = 0; iOpenInstance < 4096; iOpenInstance++)
@@ -561,5 +567,5 @@
         for (instance = 0; instance < 4096; instance++)
         {
-            VBoxAddDevState *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, instance);
+            vboxguest_state_t *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, instance);
             if (pState)
                 break;
@@ -586,5 +592,5 @@
 #ifndef USE_SESSION_HASH
     PVBOXGUESTSESSION pSession;
-    VBoxAddDevState *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, getminor(Dev));
+    vboxguest_state_t *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, getminor(Dev));
     if (!pState)
     {
@@ -700,5 +706,5 @@
      * Get the session from the soft state item.
      */
-    VBoxAddDevState *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, getminor(Dev));
+    vboxguest_state_t *pState = ddi_get_soft_state(g_pVBoxGuestSolarisState, getminor(Dev));
     if (!pState)
     {
@@ -838,5 +844,5 @@
     LogFlow((DEVICE_NAME ":VBoxGuestSolarisAddIRQ %p\n", pvState));
 
-    VBoxAddDevState *pState = (VBoxAddDevState *)pvState;
+    vboxguest_state_t *pState = (vboxguest_state_t *)pvState;
 #if 0
     /*
@@ -951,5 +957,5 @@
 static void VBoxGuestSolarisRemoveIRQ(dev_info_t *pDip, void *pvState)
 {
-    VBoxAddDevState *pState = (VBoxAddDevState *)pvState;
+    vboxguest_state_t *pState = (vboxguest_state_t *)pvState;
     LogFlow((DEVICE_NAME ":VBoxGuestSolarisRemoveIRQ pvState=%p\n"));
 
@@ -983,5 +989,5 @@
     LogFlow((DEVICE_NAME ":VBoxGuestSolarisISR Arg=%p\n", Arg));
 
-    VBoxAddDevState *pState = (VBoxAddDevState *)Arg;
+    vboxguest_state_t *pState = (vboxguest_state_t *)Arg;
     mutex_enter(&pState->Mtx);
     bool fOurIRQ = VBoxGuestCommonISR(&g_DevExt);