Index: trunk/src/VBox/VMM/VMMAll/IOMAllMMIO.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IOMAllMMIO.cpp	(revision 5999)
+++ trunk/src/VBox/VMM/VMMAll/IOMAllMMIO.cpp	(revision 7686)
@@ -44,6 +44,6 @@
 *   Internal Functions                                                         *
 *******************************************************************************/
-static bool iomGCGetRegImmData(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t *pu32Data, unsigned *pcbSize);
-static bool iomGCSaveDataToReg(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t u32Data);
+static bool iomGetRegImmData(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t *pu32Data, unsigned *pcbSize);
+static bool iomSaveDataToReg(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t u32Data);
 
 
@@ -159,5 +159,5 @@
  * @warning VBOX_SUCCESS(rc=VINF_IOM_HC_MMIO_WRITE) is TRUE!
  */
-inline int iomGCMMIODoWrite(PVM pVM, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault, const void *pvData, unsigned cbSize)
+inline int iomMMIODoWrite(PVM pVM, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault, const void *pvData, unsigned cbSize)
 {
 #ifdef VBOX_WITH_STATISTICS
@@ -180,5 +180,5 @@
  * Wrapper which does the read and updates range statistics when such are enabled.
  */
-inline int iomGCMMIODoRead(PVM pVM, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault, void *pvData, unsigned cbSize)
+inline int iomMMIODoRead(PVM pVM, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault, void *pvData, unsigned cbSize)
 {
 #ifdef VBOX_WITH_STATISTICS
@@ -210,5 +210,5 @@
  * @param   pcbSize             Where to store the size of data (1, 2, 4).
  */
-static bool iomGCGetRegImmData(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t *pu32Data, unsigned *pcbSize)
+static bool iomGetRegImmData(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, uint32_t *pu32Data, unsigned *pcbSize)
 {
     if (pParam->flags & (USE_BASE | USE_INDEX | USE_SCALE | USE_DISPLACEMENT8 | USE_DISPLACEMENT16 | USE_DISPLACEMENT32))
@@ -284,5 +284,5 @@
  * @param   u32Data             8/16/32 bit data to store.
  */
-static bool iomGCSaveDataToReg(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, unsigned u32Data)
+static bool iomSaveDataToReg(PDISCPUSTATE pCpu, PCOP_PARAMETER pParam, PCPUMCTXCORE pRegFrame, unsigned u32Data)
 {
     if (pParam->flags & (USE_BASE | USE_INDEX | USE_SCALE | USE_DISPLACEMENT8 | USE_DISPLACEMENT16 | USE_DISPLACEMENT32 | USE_IMMEDIATE8 | USE_IMMEDIATE16 | USE_IMMEDIATE32 | USE_IMMEDIATE32_SX8 | USE_IMMEDIATE16_SX8))
@@ -323,5 +323,5 @@
  * Internal - statistics only.
  */
-inline void iomGCMMIOStatLength(PVM pVM, unsigned cb)
+inline void iomMMIOStatLength(PVM pVM, unsigned cb)
 {
 #ifdef VBOX_WITH_STATISTICS
@@ -361,5 +361,5 @@
  * @param   GCPhysFault The GC physical address corresponding to pvFault.
  */
-static int iomGCInterpretMOVxXRead(PVM pVM, PCPUMCTXCORE pRegFrame, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault)
+static int iomInterpretMOVxXRead(PVM pVM, PCPUMCTXCORE pRegFrame, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault)
 {
     /*
@@ -377,5 +377,5 @@
 
     uint32_t u32Data = 0;
-    int rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &u32Data, cbSize);
+    int rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &u32Data, cbSize);
     if (rc == VINF_SUCCESS)
     {
@@ -403,10 +403,10 @@
          * Store the result to register (parameter 1).
          */
-        bool fRc = iomGCSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, u32Data);
+        bool fRc = iomSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, u32Data);
         AssertMsg(fRc, ("Failed to store register value!\n")); NOREF(fRc);
     }
 
     if (rc == VINF_SUCCESS)
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     return rc;
 }
@@ -424,5 +424,5 @@
  * @param   GCPhysFault The GC physical address corresponding to pvFault.
  */
-static int iomGCInterpretMOVxXWrite(PVM pVM, PCPUMCTXCORE pRegFrame, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault)
+static int iomInterpretMOVxXWrite(PVM pVM, PCPUMCTXCORE pRegFrame, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange, RTGCPHYS GCPhysFault)
 {
     /*
@@ -438,10 +438,10 @@
     unsigned cbSize = 0;
     uint32_t u32Data  = 0;
-    bool fRc = iomGCGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &u32Data, &cbSize);
+    bool fRc = iomGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &u32Data, &cbSize);
     AssertMsg(fRc, ("Failed to get reg/imm port number!\n")); NOREF(fRc);
 
-    int rc = iomGCMMIODoWrite(pVM, pRange, GCPhysFault, &u32Data, cbSize);
+    int rc = iomMMIODoWrite(pVM, pRange, GCPhysFault, &u32Data, cbSize);
     if (rc == VINF_SUCCESS)
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     return rc;
 }
@@ -491,6 +491,6 @@
  * @param   pRange      Pointer MMIO range.
  */
-#ifdef IOMGC_MOVS_SUPPORT
-static int iomGCInterpretMOVS(PVM pVM, RTGCUINT uErrorCode, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+#ifdef iom_MOVS_SUPPORT
+static int iomInterpretMOVS(PVM pVM, RTGCUINT uErrorCode, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstMovs, a);
@@ -577,5 +577,5 @@
                 if (rc != VINF_SUCCESS)
                     break;
-                rc = iomGCMMIODoWrite(pVM, pRange, Phys, &u32Data, cbSize);
+                rc = iomMMIODoWrite(pVM, pRange, Phys, &u32Data, cbSize);
                 if (rc != VINF_SUCCESS)
                     break;
@@ -642,8 +642,8 @@
             {
                 uint32_t u32Data;
-                rc = iomGCMMIODoRead(pVM, pRange, Phys, &u32Data, cbSize);
+                rc = iomMMIODoRead(pVM, pRange, Phys, &u32Data, cbSize);
                 if (rc != VINF_SUCCESS)
                     break;
-                rc = iomGCMMIODoWrite(pVM, pMMIODst, PhysDst, &u32Data, cbSize);
+                rc = iomMMIODoWrite(pVM, pMMIODst, PhysDst, &u32Data, cbSize);
                 if (rc != VINF_SUCCESS)
                     break;
@@ -681,5 +681,5 @@
             {
                 uint32_t u32Data;
-                rc = iomGCMMIODoRead(pVM, pRange, Phys, &u32Data, cbSize);
+                rc = iomMMIODoRead(pVM, pRange, Phys, &u32Data, cbSize);
                 if (rc != VINF_SUCCESS)
                     break;
@@ -712,5 +712,5 @@
     {
         STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstMovs, a);
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     }
     return rc;
@@ -736,5 +736,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretSTOS(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretSTOS(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstStos, a);
@@ -819,5 +819,5 @@
         do
         {
-            rc = iomGCMMIODoWrite(pVM, pRange, Phys, &u32Data, cbSize);
+            rc = iomMMIODoWrite(pVM, pRange, Phys, &u32Data, cbSize);
             if (rc != VINF_SUCCESS)
                 break;
@@ -839,5 +839,5 @@
     {
         STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstStos, a);
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     }
     return rc;
@@ -861,5 +861,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretLODS(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretLODS(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstLods, a1);
@@ -885,5 +885,5 @@
      * Perform read.
      */
-    int rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &pRegFrame->eax, cbSize);
+    int rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &pRegFrame->eax, cbSize);
     if (rc == VINF_SUCCESS)
         pRegFrame->esi += offIncrement;
@@ -895,5 +895,5 @@
     {
         STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstLods, a1);
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     }
     return rc;
@@ -916,5 +916,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretCMP(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretCMP(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstCmp, a1);
@@ -931,10 +931,10 @@
     uint32_t uData2;
     int rc;
-    if (iomGCGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
+    if (iomGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
         /* cmp reg, [MMIO]. */
-        rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
-    else if (iomGCGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
+        rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
+    else if (iomGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
         /* cmp [MMIO], reg|imm. */
-        rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
+        rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
     else
     {
@@ -951,5 +951,5 @@
 
         STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstCmp, a1);
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     }
 
@@ -973,5 +973,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretAND(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretAND(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstAnd, a1);
@@ -984,19 +984,19 @@
     bool        fAndWrite;
     int         rc;
-    if (iomGCGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
+    if (iomGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
     {
         /* and reg, [MMIO]. */
         fAndWrite = false;
         if (pRange->pfnReadCallback)
-            rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
+            rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
         else
             rc = VINF_IOM_HC_MMIO_READ;
     }
-    else if (iomGCGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
+    else if (iomGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
     {
         /* and [MMIO], reg|imm. */
         fAndWrite = true;
         if (pRange->pfnReadCallback && pRange->pfnWriteCallback)
-            rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
+            rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
         else
             rc = VINF_IOM_HC_MMIO_READ_WRITE;
@@ -1014,9 +1014,9 @@
         if (fAndWrite)
             /* Store result to MMIO. */
-            rc = iomGCMMIODoWrite(pVM, pRange, GCPhysFault, &uData1, cbSize);
+            rc = iomMMIODoWrite(pVM, pRange, GCPhysFault, &uData1, cbSize);
         else
         {
             /* Store result to register. */
-            bool fRc = iomGCSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, uData1);
+            bool fRc = iomSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, uData1);
             AssertMsg(fRc, ("Failed to store register value!\n")); NOREF(fRc);
         }
@@ -1027,5 +1027,5 @@
                                   | (eflags                &  (X86_EFL_CF | X86_EFL_PF | X86_EFL_AF | X86_EFL_ZF | X86_EFL_SF | X86_EFL_OF));
             STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstAnd, a1);
-            iomGCMMIOStatLength(pVM, cbSize);
+            iomMMIOStatLength(pVM, cbSize);
         }
     }
@@ -1051,5 +1051,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretTEST(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretTEST(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstTest, a1);
@@ -1062,17 +1062,17 @@
     int         rc;
 
-    if (iomGCGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
+    if (iomGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
     {
         /* and test, [MMIO]. */
         if (pRange->pfnReadCallback)
-            rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
+            rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
         else
             rc = VINF_IOM_HC_MMIO_READ;
     }
-    else if (iomGCGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
+    else if (iomGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
     {
         /* test [MMIO], reg|imm. */
         if (pRange->pfnReadCallback)
-            rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
+            rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
         else
             rc = VINF_IOM_HC_MMIO_READ;
@@ -1091,5 +1091,5 @@
                               | (eflags                &  (X86_EFL_CF | X86_EFL_PF | X86_EFL_AF | X86_EFL_ZF | X86_EFL_SF | X86_EFL_OF));
         STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstTest, a1);
-        iomGCMMIOStatLength(pVM, cbSize);
+        iomMMIOStatLength(pVM, cbSize);
     }
 
@@ -1112,5 +1112,5 @@
  * @param   pRange      Pointer MMIO range.
  */
-static int iomGCInterpretXCHG(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
+static int iomInterpretXCHG(PVM pVM, PCPUMCTXCORE pRegFrame, RTGCPHYS GCPhysFault, PDISCPUSTATE pCpu, CTXALLSUFF(PIOMMMIORANGE) pRange)
 {
     STAM_PROFILE_START(&pVM->iom.s.StatGCInstTest, a1);
@@ -1128,17 +1128,17 @@
     }
 
-    if (iomGCGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
+    if (iomGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uData1, &cbSize))
     {
         /* xchg reg, [MMIO]. */
-        rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
+        rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData2, cbSize);
         if (rc == VINF_SUCCESS)
         {
             /* Store result to MMIO. */
-            rc = iomGCMMIODoWrite(pVM, pRange, GCPhysFault, &uData1, cbSize);
+            rc = iomMMIODoWrite(pVM, pRange, GCPhysFault, &uData1, cbSize);
 
             if (rc == VINF_SUCCESS)
             {
                 /* Store result to register. */
-                bool fRc = iomGCSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, uData2);
+                bool fRc = iomSaveDataToReg(pCpu, &pCpu->param1, pRegFrame, uData2);
                 AssertMsg(fRc, ("Failed to store register value!\n")); NOREF(fRc);
             }
@@ -1150,17 +1150,17 @@
     }
     else
-    if (iomGCGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
+    if (iomGetRegImmData(pCpu, &pCpu->param2, pRegFrame, &uData2, &cbSize))
     {
         /* xchg [MMIO], reg. */
-        rc = iomGCMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
+        rc = iomMMIODoRead(pVM, pRange, GCPhysFault, &uData1, cbSize);
         if (rc == VINF_SUCCESS)
         {
             /* Store result to MMIO. */
-            rc = iomGCMMIODoWrite(pVM, pRange, GCPhysFault, &uData2, cbSize);
+            rc = iomMMIODoWrite(pVM, pRange, GCPhysFault, &uData2, cbSize);
 
             if (rc == VINF_SUCCESS)
             {
                 /* Store result to register. */
-                bool fRc = iomGCSaveDataToReg(pCpu, &pCpu->param2, pRegFrame, uData1);
+                bool fRc = iomSaveDataToReg(pCpu, &pCpu->param2, pRegFrame, uData1);
                 AssertMsg(fRc, ("Failed to store register value!\n")); NOREF(fRc);
             }
@@ -1296,7 +1296,7 @@
                 STAM_PROFILE_START(&pVM->iom.s.StatGCInstMov, b);
                 if (uErrorCode & X86_TRAP_PF_RW)
-                    rc = iomGCInterpretMOVxXWrite(pVM, pRegFrame, &cpu, pRange, GCPhysFault);
+                    rc = iomInterpretMOVxXWrite(pVM, pRegFrame, &cpu, pRange, GCPhysFault);
                 else
-                    rc = iomGCInterpretMOVxXRead(pVM, pRegFrame, &cpu, pRange, GCPhysFault);
+                    rc = iomInterpretMOVxXRead(pVM, pRegFrame, &cpu, pRange, GCPhysFault);
                 if (rc == VINF_SUCCESS)
                     STAM_PROFILE_STOP(&pVM->iom.s.StatGCInstMov, b);
@@ -1305,8 +1305,8 @@
 
 
-#ifdef IOMGC_MOVS_SUPPORT
+#ifdef iom_MOVS_SUPPORT
             case OP_MOVSB:
             case OP_MOVSWD:
-                rc = iomGCInterpretMOVS(pVM, uErrorCode, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretMOVS(pVM, uErrorCode, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 #endif
@@ -1315,5 +1315,5 @@
             case OP_STOSWD:
                 Assert(uErrorCode & X86_TRAP_PF_RW);
-                rc = iomGCInterpretSTOS(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretSTOS(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
@@ -1321,5 +1321,5 @@
             case OP_LODSWD:
                 Assert(!(uErrorCode & X86_TRAP_PF_RW));
-                rc = iomGCInterpretLODS(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretLODS(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
@@ -1327,18 +1327,18 @@
             case OP_CMP:
                 Assert(!(uErrorCode & X86_TRAP_PF_RW));
-                rc = iomGCInterpretCMP(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretCMP(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
             case OP_AND:
-                rc = iomGCInterpretAND(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretAND(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
             case OP_TEST:
                 Assert(!(uErrorCode & X86_TRAP_PF_RW));
-                rc = iomGCInterpretTEST(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretTEST(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
             case OP_XCHG:
-                rc = iomGCInterpretXCHG(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
+                rc = iomInterpretXCHG(pVM, pRegFrame, GCPhysFault, &cpu, pRange);
                 break;
 
@@ -1867,5 +1867,5 @@
     uint32_t    uPort = 0;
     unsigned    cbSize = 0;
-    bool fRc = iomGCGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uPort, &cbSize);
+    bool fRc = iomGetRegImmData(pCpu, &pCpu->param1, pRegFrame, &uPort, &cbSize);
     AssertMsg(fRc, ("Failed to get reg/imm port number!\n")); NOREF(fRc);
     if (pCpu->pCurInstr->opcode == OP_OUTSB)